with Reps, Reps.Ops, Reps.IO, Comps,Comps.Ops,Comps.IO, Beltrami_Ops, Messages,Ada.Numerics.Generic_Elementary_Functions,Ada.Characters.Latin_1, Ada.Calendar;
use Reps, Reps.Ops, Reps.IO,  Comps,Comps.Ops,Comps.IO, Ada.Calendar;
use Messages;
with Ada.Text_IO,Ada.Float_Text_IO;
use Ada.Text_IO,Ada.Float_Text_IO;
with Ada.Text_IO.COMPLEX_IO ;
with GetOpt;
use GetOpt;
with Ada.Command_Line;
use Ada.Command_Line;
with Ada.Strings.Unbounded;
use Ada.Strings.Unbounded;
with Lin, Lin.Ops,Lin.IO;


pragma Elaborate_All(Reps.Ops);

procedure Beltrami is

   pragma Suppress(Storage_Check);

   package Current_Beltrami is new Beltrami_Ops;
   use Current_Beltrami,Current_Beltrami.Lin_Alg,Current_Beltrami.Lin_Alg_Ops,Current_Beltrami.Lin_Alg_IO;
   package Txt_Int_IO is new Ada.Text_IO.Integer_IO(Integer);
   use Txt_Int_IO;

   Err,Er,R,Del: Rep;
   F2_Val_At_One,F2_Val_At_Zero,Mu_Val_At_Center,C: Comp;
   Nor,Te,Iter,N,K,K1,K2,Transform,Ind,Out_Format,In_Format,Switch: Integer;
   F,FF: File_Type;
   Test_String : String := "p:r:o:i:s:f:a:e:n:T P R S D";
   Optchar : character;
   Va   : Integer;
   Tr,Out_Name,In_Name:  Ada.Strings.Unbounded.Unbounded_String;
   StartTime, EndTime: Time;
begin

   Te:=0;
   Out_Name:=To_Unbounded_String("output");
   Iter:=10;
   Out_Format:=0;
   In_Format:=0;
   Er:=Rep(1.0E-8);
   Transform:=3;
   Nor:=0;
   Switch:=1;

   --Options
   Getopt.Opterr := 1;
   loop
      Va := Getopt.Getopt( Test_String );
      exit when Va = -1;

      optchar :=  Character'Val( Va );
      case optchar is
         when 'o' =>
            Out_Name:=To_Unbounded_String(To_String(Getopt.Optarg));
         when 'f' =>
            Out_Format:=Integer'Value(To_String(Getopt.Optarg));
         when 's' =>
            In_Format:=Integer'Value(To_String(Getopt.Optarg));
         when 'i' =>
            Iter:=Integer'Value(To_String(Getopt.Optarg));
         when 'a' =>
            Te:=Integer'Value(To_String(Getopt.Optarg));
         when 'n' =>
            Nor:=Integer'Value(To_String(Getopt.Optarg));
         when 'r' =>
            Switch:=Integer'Value(To_String(Getopt.Optarg));
         when 'e' =>
            Er:=Rep'Value(To_String(Getopt.Optarg));
         when 'T' =>
            Transform:=1;
         when 'P' =>
            Transform:=2;
         when 'R' =>
            Transform:=3;
         when 'S' =>
            Transform:=4;
         when 'D' =>
            Transform:=5;
         when others =>
            New_Line;
            Message("wrong option in beltrami",Parameter_Error);
      end case;
   end loop;

   Ind:= Getopt.Optind;
   In_Name:=To_Unbounded_String(Argument(Ind));


   --Transforms
   if Transform=1 or Transform=2 then

      Open(F,In_File,To_String(In_Name));
      Get(F,N); Get(F,K);
      K1:=-K/2;
      K2:=K/2-1;
      Del:=Two*Pi/Rep(K);
      declare
         Belt: Matrix(-N..0,K1..K2);
         Rad: RepArray(-N..0);
      begin
         Rad(Rad'First):=Zero;
         for I in Rad'First+1..Rad'Last loop
            Txt_Get(F,R);
            Rad(I):=R;
         end loop;
         Get(F,Mu_Val_At_Center);

         if In_Format=0 then
            for J in Belt'Range(2) loop
               Belt(Belt'First(1),J):=Mu_Val_At_Center;
            end loop;
         elsif In_Format=1 then
            for J in Belt'Range(2) loop
               Belt(Belt'First(1),J):=Comp_Zero;
            end loop;
            Belt(Belt'First(1),0):=Mu_Val_At_Center;
         else
            Message("input format in beltrami",Parameter_Error);
         end if;

         for I in Belt'First(1)+1..Belt'Last(1) loop
            if Switch=0 then

               for J in 0..Belt'Last(2) loop
                  Get(F,C);
                  Belt(I,J):=C;
               end loop;
               for J in Belt'First(2)..-1 loop
                  Get(F,C);
                  Belt(I,J):=C;
               end loop;

            elsif Switch=1 then
               for J in Belt'Range(2) loop
                  Get(F,C);
                  Belt(I,J):=C;
               end loop;
            else
               Message("range option in beltrami",Parameter_Error);
            end if;
         end loop;
         Close(F);

         if Te=1 then
            New_Line;
            Put("The radius of the disk:=");Txt_Put(Current_Output,Rad(0));
            New_Line;
            Put("Radial grid dimensions:=(");ShortPut(-N);Put(",");ShortPut(0);Put(")");
            New_Line;
            Put("Angular grid dimensions:=(");ShortPut(K1);Put(",");ShortPut(K2);Put(")");
            New_Line;
            Put("Angular grid size:=");Txt_Put(Current_Output,Two*Pi/Rep(K2-K1));
         end if;

         if Te=1 then
            New_Line;
            if Transform=1 then
               Put("Hilbert transform: executed once");
            else
               Put("Cauchy transform: executed once");
            end if;
         end if;

         if In_Format=0 then
            FT(Belt);
         elsif In_Format=1 then
            null;
         else
            Message("input format in beltrami",Parameter_Error);
         end if;

         if Transform =1 then
            TT_Transform(Rad,Belt);
         else
            PP_Transform(Rad,Belt);
         end if;

         if Out_Format=0 then
            FT(Belt,True);
         elsif Out_Format=1 then
            null;
         else
            Message("output format in beltrami",Parameter_Error);
         end if;


         Create(F,Out_File,To_String(Out_Name));
         Put(F,N); Put(F,K);
         New_Line(F);
         for I in Rad'First+1..Rad'Last loop
            Txt_Put(F,Rad(I));
            New_Line(F);
         end loop;
         Put(F,Belt(Belt'First(1),0),True,True);
         New_Line(F);
         for I in Belt'First(1)+1..Belt'Last(1) loop
            if Switch=0 then

               for J in 0..Belt'Last(2) loop
                  Put(F,Belt(I,J),True,True);
               end loop;
               for J in Belt'First(2)..-1 loop
                  Put(F,Belt(I,J),True,True);
               end loop;

            elsif Switch=1 then
               for J in Belt'Range(2) loop
                  Put(F,Belt(I,J),True,True);
               end loop;
            else
               Message("range option in beltrami",Parameter_Error);
            end if;
            New_Line(F);
         end loop;
         Close(F);
      end;

   elsif Transform=3 then

      Open(F,In_File,To_String(In_Name));
      Get(F,N); Get(F,K);
      K1:=-K/2;
      K2:=K/2-1;
      Del:=Two*Pi/Rep(K);
      declare
         F2,Belt,Temp: Matrix(-N..0,K1..K2);
         Rad: RepArray(-N..0);
      begin
         Rad(Rad'First):=Zero;
         for I in Rad'First+1..Rad'Last loop
            Txt_Get(F,R);
            Rad(I):=R;
         end loop;
         Get(F,Mu_Val_At_Center);

         if In_Format=0 then
            for J in Belt'Range(2) loop
               Belt(Belt'First(1),J):=Mu_Val_At_Center;
            end loop;
         elsif In_Format=1 then
            for J in Belt'Range(2) loop
               Belt(Belt'First(1),J):=Comp_Zero;
            end loop;
            Belt(Belt'First(1),0):=Mu_Val_At_Center;
         else
            Message("input format in beltrami",Parameter_Error);
         end if;

         for I in Belt'First(1)+1..Belt'Last(1) loop
            if Switch=0 then
               for J in 0..Belt'Last(2) loop
                  Get(F,C);
                  Belt(I,J):=C;
               end loop;
               for J in Belt'First(2)..-1 loop
                  Get(F,C);
                  Belt(I,J):=C;
                end loop;
            elsif Switch=1 then
               for J in Belt'Range(2) loop
                  Get(F,C);
                  Belt(I,J):=C;
               end loop;
            else
               Message("range option in beltrami",Parameter_Error);
            end if;
         end loop;

         Close(F);

         if Te=1 then
            New_Line;
            Put("The radius of the disk:=");Txt_Put(Current_Output,Rad(0));
            New_Line;
            Put("Radial grid dimensions:=(");ShortPut(-N);Put(",");ShortPut(0);Put(")");
            New_Line;
            Put("Angular grid dimensions:=(");ShortPut(K1);Put(",");ShortPut(K2);Put(")");
            New_Line;
            Put("Angular grid size:=");Txt_Put(Current_Output,Two*Pi/Rep(K2-K1));
            New_Line;
            Put("Iterations in T_Transform:=");ShortPut(Iter);
            New_Line;
            Put("Precision in l_1 norm:=");Txt_Put(Current_Output,Er);
         end if;

         if Te=1 then
            New_Line;
            Put("Hilbert transform:");
         end if;

         if In_Format=0 then
            null;
         elsif In_Format=1 then
            FT(Belt,True);
         else
            Message("input format in beltrami",Parameter_Error);
         end if;

         F2:=Belt;

         for I in 1..Iter loop
            Temp:=F2;
            FT(F2,True);
            PointsProdAdd(Belt,F2);
            FT(F2);
            TT_Transform(Rad,F2);
            Err:=NormInf(F2-Temp);
            if Te=1 then
               New_Line;
               Put("l_inf norm error at "); ShortPut(I); Put("-th iteration:");  Txt_Put(Current_Output,Err);
            end if;
            if Err<Er then
               if Te=1 then
                  New_Line;
                  Put("Smallness criterion satisfied: exitting the Hilbert transform loop");
               end if;
               exit;
            end if;
            if I=Iter then
               if Te=1 then
                  New_Line;
                  Put("Maximum number of iterations: exitting the Hilbert transform loop and the program");
               end if;
               exit;
            end if;
         end loop;

         if Te=1 then
            New_Line;
            Put("Cauchy transform:");
         end if;
         FT(F2,True);
         PointsProdAdd(Belt,F2);
         FT(F2);
         PP_Transform(Rad,F2);
         if Te=1 then
            Put(" done");
         end if;

         if Te=1 then
            New_Line;
            Put("Adding identity:");
         end if;

         for I in F2'Range(1) loop
            F2(I,1):=F2(I,1)+Complecs(Rad(I),Zero);
         end loop;
         if Te=1 then
            Put(" done");
         end if;

         if Nor=1 then
            if Te=1 then
               New_Line;
               Put("Normalization:");
            end if;
            if One>Rad(Rad'Last) then
               Message("normalization impossible: one lies outside of the disk",Parameter_Error);
            end if;
            F2_Val_At_Zero:=F2(F2'First(1),0);
            F2_Val_At_One:=Value(Rad,Comp_Zero,F2,Comp_One);
            FT(F2,True);
            for I in F2'Range(1) loop
               for J in F2'Range(2) loop
                  F2(I,J):=(F2(I,J)-F2_Val_At_Zero)/(F2_Val_At_One-F2_Val_At_Zero);
               end loop;
            end loop;
            if Te=1 then
               Put(" done");
            end if;

            if Te=1 then
               Temp:=F2;
               FT(Temp);
               New_Line;
               Put("Value of the solution at zero:=");Show(Value(Rad,Comp_Zero,Temp,Comp_Zero));
               New_Line;
               Put("Value of the solution at one:=");Show(Value(Rad,Comp_Zero,Temp,Comp_One));
            end if;
         elsif Nor=0 then
            FT(F2,True);
         else
            Message("invalid normalization option in beltrami",Parameter_Error);
         end if;

         if Out_Format=0 then
            null;
         elsif Out_Format=1 then
            FT(F2);
         else
            Message("output format in beltrami",Parameter_Error);
         end if;

         Create(F,Out_File,To_String(Out_Name));
         Put(F,N); Put(F,K);
         New_Line(F);
         for I in Rad'First+1..Rad'Last loop
            Txt_Put(F,Rad(I));
            New_Line(F);
         end loop;
         Put(F,F2(F2'First(1),0),True,True);
         New_Line(F);
         for I in F2'First(1)+1..F2'Last(1) loop
            if Switch=0 then

               for J in 0..Belt'Last(2) loop
                  Put(F,F2(I,J),False,True);
               end loop;
               for J in Belt'First(2)..-1 loop
                  Put(F,F2(I,J),False,True);
               end loop;

            elsif Switch=1 then
               for J in Belt'Range(2) loop
                  Put(F,F2(I,J),False,True);
               end loop;
            else
               Message("range option in beltrami",Parameter_Error);
            end if;

            New_Line(F);
         end loop;
         Close(F);
      end;
   elsif Transform=4 then

      Open(F,In_File,To_String(In_Name));
      Get(F,N); Get(F,K);
      K1:=-K/2;
      K2:=K/2-1;
      Del:=Two*Pi/Rep(K);
      declare
         F2,Belt,Temp: Matrix(-N..0,K1..K2);
         Rad: RepArray(-N..0);
      begin
         Rad(Rad'First):=Zero;
         for I in Rad'First+1..Rad'Last loop
            Txt_Get(F,R);
            Rad(I):=R;
         end loop;
         Get(F,Mu_Val_At_Center);

         if In_Format=0 then
            for J in Belt'Range(2) loop
               Belt(Belt'First(1),J):=Mu_Val_At_Center;
            end loop;
         elsif In_Format=1 then
            for J in Belt'Range(2) loop
               Belt(Belt'First(1),J):=Comp_Zero;
            end loop;
            Belt(Belt'First(1),0):=Mu_Val_At_Center;
         else
            Message("input format in beltrami",Parameter_Error);
         end if;

         for I in Belt'First(1)+1..Belt'Last(1) loop
            if Switch=0 then
               for J in 0..Belt'Last(2) loop
                  Get(F,C);
                  Belt(I,J):=C;
               end loop;
               for J in Belt'First(2)..-1 loop
                  Get(F,C);
                  Belt(I,J):=C;
                end loop;
            elsif Switch=1 then
               for J in Belt'Range(2) loop
                  Get(F,C);
                  Belt(I,J):=C;
               end loop;
            else
               Message("range option in beltrami",Parameter_Error);
            end if;
         end loop;

         Close(F);

         if Te=1 then
            New_Line;
            Put("The radius of the disk:=");Txt_Put(Current_Output,Rad(0));
            New_Line;
            Put("Radial grid dimensions:=(");ShortPut(-N);Put(",");ShortPut(0);Put(")");
            New_Line;
            Put("Angular grid dimensions:=(");ShortPut(K1);Put(",");ShortPut(K2);Put(")");
            New_Line;
            Put("Angular grid size:=");Txt_Put(Current_Output,Two*Pi/Rep(K2-K1));
            New_Line;
            Put("Iterations in the loop:=");ShortPut(Iter);
            New_Line;
            Put("Precision in l_1 norm:=");Txt_Put(Current_Output,Er);
         end if;

         if Te=1 then
            New_Line;
            Put("h -> T(mu*(h+1)):");
         end if;

         if In_Format=0 then
            null;
         elsif In_Format=1 then
            FT(Belt,True);
         else
            Message("input format in beltrami",Parameter_Error);
         end if;

         F2:=Belt;
         StartTime:=Clock;
         for I in 1..Iter loop
            Temp:=F2;
            FT(F2);
            TT_Transform(Rad,F2);
            FT(F2,True);
            PointsProdAdd(Belt,F2);
            Err:=NormInf(F2-Temp);
            if Te=1 then
               New_Line;
               Put("l_inf norm error at "); ShortPut(I); Put("-th iteration:");  Txt_Put(Current_Output,Err);
            end if;
            if I=Iter then
               if Te=1 then
                  New_Line;
                  Put("Maximum number of iterations: exitting the loop and the program");
               end if;
               exit;
            end if;
         end loop;
         EndTime:=Clock;
         New_Line;
         Put("Runtime =");Put(Item =>Integer(Seconds(EndTime)-Seconds(StartTime)), Width => 2);


         if Out_Format=0 then
            null;
         elsif Out_Format=1 then
            FT(F2);
         else
            Message("output format in beltrami",Parameter_Error);
         end if;

         Create(F,Out_File,To_String(Out_Name));
         Put(F,N); Put(F,K);
         New_Line(F);
         for I in Rad'First+1..Rad'Last loop
            Txt_Put(F,Rad(I));
            New_Line(F);
         end loop;
         Put(F,F2(F2'First(1),0),True,True);
         New_Line(F);
         for I in F2'First(1)+1..F2'Last(1) loop
            if Switch=0 then

               for J in 0..Belt'Last(2) loop
                  Put(F,F2(I,J),True,True);
               end loop;
               for J in Belt'First(2)..-1 loop
                  Put(F,F2(I,J),True,True);
               end loop;

            elsif Switch=1 then
               for J in Belt'Range(2) loop
                  Put(F,F2(I,J),True,True);
               end loop;
            else
               Message("range option in beltrami",Parameter_Error);
            end if;

            New_Line(F);
         end loop;
         Close(F);
      end;
   elsif Transform=5 then

      Open(F,In_File,To_String(In_Name));
      Get(F,N); Get(F,K);
      K1:=-K/2;
      K2:=K/2-1;
      Del:=Two*Pi/Rep(K);
      declare
         F3,F2,Belt,Temp: Matrix(-N..0,K1..K2);
         Rad: RepArray(-N..0);
      begin
         Rad(Rad'First):=Zero;
         for I in Rad'First+1..Rad'Last loop
            Txt_Get(F,R);
            Rad(I):=R;
         end loop;
         Get(F,Mu_Val_At_Center);

         if In_Format=0 then
            for J in Belt'Range(2) loop
               Belt(Belt'First(1),J):=Mu_Val_At_Center;
            end loop;
         elsif In_Format=1 then
            for J in Belt'Range(2) loop
               Belt(Belt'First(1),J):=Comp_Zero;
            end loop;
            Belt(Belt'First(1),0):=Mu_Val_At_Center;
         else
            Message("input format in beltrami",Parameter_Error);
         end if;

         for I in Belt'First(1)+1..Belt'Last(1) loop
            if Switch=0 then
               for J in 0..Belt'Last(2) loop
                  Get(F,C);
                  Belt(I,J):=C;
               end loop;
               for J in Belt'First(2)..-1 loop
                  Get(F,C);
                  Belt(I,J):=C;
                end loop;
            elsif Switch=1 then
               for J in Belt'Range(2) loop
                  Get(F,C);
                  Belt(I,J):=C;
               end loop;
            else
               Message("range option in beltrami",Parameter_Error);
            end if;
         end loop;

         Close(F);

         if Te=1 then
            New_Line;
            Put("The radius of the disk of support:=");Txt_Put(Current_Output,Rad(0));
            New_Line;
            Put("Radial grid dimensions:=(");ShortPut(-N);Put(",");ShortPut(0);Put(")");
            New_Line;
            Put("Angular grid dimensions:=(");ShortPut(K1);Put(",");ShortPut(K2);Put(")");
            New_Line;
            Put("Angular grid size:=");Txt_Put(Current_Output,Two*Pi/Rep(K2-K1));
            New_Line;
            Put("Iterations in the loop:=");ShortPut(Iter);
            New_Line;
            Put("Precision in l_1 norm:=");Txt_Put(Current_Output,Er);
         end if;

         if Te=1 then
            New_Line;
            Put("h -> P(mu*(h+1))_z:");
         end if;

         if In_Format=0 then
            null;
         elsif In_Format=1 then
            FT(Belt,True);
         else
            Message("input format in beltrami",Parameter_Error);
         end if;

         F2:=Belt;

         StartTime:=Clock;
         for I in 1..Iter loop
            Temp:=F2;
            FT(F2);
            P_Transform(Rad,F2);

            for I1 in F2'First(1)..F2'Last(1)-1 loop
               if I1=F2'First(1) then
                  for I2 in F2'First(2)..F2'Last(2)-1 loop
                     F3(I1,I2):=Half*((F2(I1+1,I2+1)-F2(I1,I2+1))/(Rad(I1+1)-Rad(I1)));
                  end loop;
               else
                  for I2 in F2'First(2)..F2'Last(2)-1 loop
                     F3(I1,I2):=Half*((F2(I1+1,I2+1)-F2(I1,I2+1))/(Rad(I1+1)-Rad(I1))+Rep(I2+1)*F2(I1,I2+1)/Rad(I1));
                  end loop;
               end if;
            end loop;

            for I1 in F2'Range(1) loop
               F3(I1,F2'Last(2)):=Comp_Zero;
            end loop;

            for I2 in F2'First(2)..F2'Last(2)-1 loop
               F3(F2'Last(1),I2):=Half*((F2(F2'Last(1),I2+1)-F2(F2'Last(1)-1,I2+1))/(Rad(F2'Last(1))-Rad(F2'Last(1)-1))+Rep(I2+1)*F2(F2'Last(1),I2+1)/Rad(F2'Last(1)));
            end loop;
            P_Transform(Rad,F3);

            FT(F3,True);
            F2:=F3;
            PointsProdAdd(Belt,F2);
            Err:=NormInf(F2-Temp);
            if Te=1 then
               New_Line;
               Put("l_inf norm error at "); ShortPut(I); Put("-th iteration:");  Txt_Put(Current_Output,Err);
               end if;
               if I=Iter then
                  if Te=1 then
                     New_Line;
                     Put("Maximum number of iterations: exitting the loop and the program");
                  end if;
                  exit;
               end if;
         end loop;
         EndTime:=Clock;
         New_Line;
         Put("Runtime =");Put(Item =>Integer(Seconds(EndTime)-Seconds(StartTime)), Width => 2);

         if Out_Format=0 then
            null;
         elsif Out_Format=1 then
            FT(F2);
         else
            Message("output format in beltrami",Parameter_Error);
         end if;

         Create(F,Out_File,To_String(Out_Name));
         Put(F,N); Put(F,K);
         New_Line(F);
         for I in Rad'First+1..Rad'Last loop
            Txt_Put(F,Rad(I));
            New_Line(F);
         end loop;
         Put(F,F2(F2'First(1),0),True,True);
         New_Line(F);
         for I in F2'First(1)+1..F2'Last(1) loop
            if Switch=0 then

               for J in 0..Belt'Last(2) loop
                  Put(F,F2(I,J),False,True);
               end loop;
               for J in Belt'First(2)..-1 loop
                  Put(F,F2(I,J),False,True);
               end loop;

            elsif Switch=1 then
               for J in Belt'Range(2) loop
                  Put(F,F2(I,J),False,True);
               end loop;
            else
               Message("range option in beltrami",Parameter_Error);
            end if;

            New_Line(F);
         end loop;
         Close(F);
      end;
   else
      Message("transform in beltrami",Parameter_Error);
   end if;
end Beltrami;



























