with Ada.Text_IO, Reps,Reps.Ops, Reps.IO,Comps,Comps.Ops,Comps.IO;
use Ada.Text_IO, Reps,Reps.Ops, Reps.IO,Comps,Comps.Ops,Comps.IO;
with Lin, Lin.Ops,Lin.IO;
with Round_Up;
pragma Elaborate_All (Ada.Text_IO);

generic
package Beltrami_Ops is

   package Lin_Alg is new Lin;
   package Lin_Alg_Ops  is new Lin_Alg.Ops;
   package Lin_Alg_IO  is new Lin_Alg.IO;
   use Lin_Alg, Lin_Alg_Ops,  Lin_Alg_IO;

   function T_TestFunc(R_0: Radius; P,Q:  Integer; C: Comp) return Comp;                               --returns the T[z^p * conj(z)^q](z) for p,q>0
   function P_TestFunc(R_0: Radius; P,Q:  Integer; C: Comp) return Comp;                               --returns the P[z^p * conj(z)^q](z) for p,q>0
   procedure Glassman (A, B, C:   in  Integer; Data_Vector:   in out Vector ;
                                               Inverse_Transform:  in  Boolean:=False   );             --Glassman factorization
   procedure FFT (FFT_Data:  in out Vector; Inverse_Transform: in   Boolean:=False   );                --FFT of a linear array
   procedure FT(H: in Matrix; FH: out Matrix; Inverse_Transform: in   Boolean:=False );                --FFT of 2D array
   procedure FT(H: in out Matrix; Inverse_Transform: in   Boolean:=False );                            --FFT of 2D array

   function Value(V: in Vector; C: in Comp) return Comp;                                               --value of a Fourier series V at C
   function Value(Rad: in RepArray; Centre: in Comp; F: in Matrix; C: in Comp) return Comp;            --v --FFT of 2D arrayalue of a Fourier series centered on Centre F at C

   procedure T_Transform(R: in RepArray; H: in out Matrix; Text_Output: in Boolean:=False);            --Hilbert transform for linear data
   procedure T_Transform(Lg,R: in RepArray; S: in RealMatrix; H: in out Matrix;
                                                              Text_Output: in Boolean:=False);         --fast Hilbert transform for linear data
   procedure P_Transform(Rad: in RepArray; H: in out Matrix; Text_Output: in Boolean:=False);          --Fourier transform for linear data
   procedure TT_Transform(R: in RepArray; H: in out Matrix; Text_Output: in Boolean:=False);           --Hilbert transform for constant data
   procedure PP_Transform(Rad: in RepArray; H: in out Matrix; Text_Output: in Boolean:=False);         --Cauchy transform for constant data
end Beltrami_Ops;
