with Reps.Ops;
use Reps.Ops;

package body Comps.Ops is

   procedure RandomComp(Seed: in out Long_Integer; C: out Comp) is
      Re,Im: Rep;
   begin
     NextRandom(Seed);
     Re:=One-Two*Rep(Seed)/Rep(2147483647);
     NextRandom(Seed);
     Im:=One-Two*Rep(Seed)/Rep(2147483647);
     C:=Complecs(Re,Im);
   end RandomComp;

   function Inv(S: Comp) return Comp is
   begin
      return  One/S;
   end Inv;


   function Exp(S: Comp) return Comp is
   begin
      if S=Comp_Zero then return Comp_One; end if;   -- S=0
      declare
        X,Y: Comp;
      begin
         declare
            Iter: constant Integer := 6;
            K: Integer := 0;
           R: Rep;
         begin
            R := AbsVal(S);
            while R>Quarter loop
               K := K+1;
              R := R*Half;
            end loop;
            X := (Half**K)*S;
           Y := Comp_Zero;
           for I in reverse 1 .. Iter loop
              Y := Comp_One+(X*Y)/Rep(I);
           end loop;
           for I in 1 .. K loop
              Y := Y*Y;
           end loop;
           return Y;
         end;
     end;
  end Exp;
end Comps.Ops;
