package Comps.Ops is

--   pragma Pure;
   package Complex_Func is new Ada.Numerics.Generic_Complex_Elementary_Functions(Complex_Types);
   use Complex_Func;

   function Inv(S: Comp) return Comp;
   procedure RandomComp(Seed: in out Long_Integer; C: out Comp);
   function Exp(S: Comp) return Comp;


   function Neg(C: Comp) return Comp  renames Complex_Types."-";
   function "-"(S,T: Comp) return Comp renames Complex_Types."-";
   function "-"(S: Comp) return Comp  renames Complex_Types."-";
   function "+"(S,T: Comp) return Comp  renames Complex_Types."+";
   function "*"(S,T: Comp) return Comp renames Complex_Types."*";
   function "**"(S: Comp; I: Integer) return Comp renames Complex_Types."**";
   function "/"(S: Comp; R: Rep) return Comp  renames Complex_Types."/";
   function "/"(R: Rep; S: Comp) return Comp  renames Complex_Types."/";
   function "/"(R: Comp; S: Comp) return Comp  renames Complex_Types."/";
   function "*"(R: Rep; S: Comp) return Comp  renames Complex_Types."*";
   function Arg(C: Comp) return Rep renames  Complex_Types.Argument;
   function Polar(M,A: Rep) return Comp  renames Complex_Types.Compose_From_Polar;
   function AbsVal(C: Comp) return Rep  renames Complex_Types."abs";
   function Cos(S: Comp) return Comp  renames Complex_Func.Cos;
   function Sin(S: Comp) return Comp  renames Complex_Func.Sin;
   function Log(S: Comp) return Comp renames Complex_Func.Log;
   function Sqrt(S: Comp) return Comp renames Complex_Func.Sqrt;
   function "="(S,T: Comp) return Boolean renames Complex_Types."=";
end Comps.Ops;
