with Reps, Ada.Numerics.Generic_Complex_Types,  Ada.Numerics.Generic_Complex_Elementary_Functions;
use Reps;

package Comps is

   pragma Pure;
   package Complex_Types is new Ada.Numerics.Generic_Complex_Types(Rep);
   use Complex_Types;

   subtype Comp is Complex_Types.Complex;

   Comp_Zero: constant Comp:=(Zero,Zero);
   Comp_One: constant Comp:=(One,Zero);
   Comp_Two: constant Comp:=(Two,Zero);
   Comp_Half: constant Comp:=(Half,Zero);
   Comp_I: constant Comp:=(Zero,One);

   function RealPart(C: Comp) return Rep renames Complex_Types.Re;
   function ImPart(C: Comp) return Rep  renames Complex_Types.Im;
   function Complecs(Re,Im: Rep) return Comp  renames Complex_Types.Compose_From_Cartesian;
   function Complecs(Re,Im: Integer) return Comp;
   function Conj(C: Comp) return Comp;
   function Complecs(C: Comp) return Comp;

   Undefined: exception;
end Comps;
