with Ada.Text_IO, Ada.Sequential_IO;
with Reps.IO,Comps.IO;
use Reps.IO,Comps.IO;

pragma Elaborate_All (Ada.Text_IO, Ada.Sequential_IO);

package body Lin.IO is

   pragma Suppress(Storage_Check);

   package Txt_Int_IO is new Ada.Text_IO.Integer_IO(Integer);
   package Txt_Rep_IO is new Ada.Text_IO.Float_IO(Rep);
   package Seq_Rep_IO is new Ada.Sequential_IO(Rep);


   procedure Show(B: in Vector; Cut: in Rep := Zero) is
      use Ada.Text_IO, Txt_Int_IO;
   begin
      for I in B'Range loop
         if AbsVal(B(I))>Cut then
            Put("B(");
            Put(I,2);
            Put(") = ");
            Txt_Put(Current_Output,RealPart(B(I)));Put(",");Txt_Put(Current_Output,ImPart(B(I)));Put(")");
            New_Line;
         end if;
      end loop;
      New_Line;
   end Show;


   procedure Show(A: in Matrix; Cut: in Rep := Zero) is
      use Ada.Text_IO, Txt_Int_IO;
   begin
      for I in A'Range(1) loop
         for J in A'Range(2) loop
            if AbsVal(A(I,J))>Cut then
               Put("A(");
               Put(I,2);
               Put(",");
               Put(J,2);
               Put(") = ");
               Txt_Put(Current_Output,RealPart(A(I,J)));Put(",");Txt_Put(Current_Output,ImPart(A(I,J)));Put(")");
               New_Line;
            end if;
         end loop;
      end loop;
      New_Line;
   end Show;


   procedure Show(B: in RealVector; Cut: in Rep := Zero) is
      use Ada.Text_IO, Txt_Int_IO;
   begin
      for I in B'Range loop
         if Abs(B(I))>Cut then
            Put("B(");
            Put(I,2);
            Put(") = ");
            Txt_Put(Current_Output,B(I));
            New_Line;
         end if;
      end loop;
      New_Line;
   end Show;


   procedure Show(B: in RepArray; Cut: in Rep := Zero) is
      use Ada.Text_IO, Txt_Int_IO;
   begin
      for I in B'Range loop
         if Abs(B(I))>Cut then
            Put("R(");
            Put(I,2);
            Put(") = ");
            Txt_Put(Current_Output,B(I));
            New_Line;
         end if;
      end loop;
      New_Line;
   end Show;


   procedure Show(A: in RealMatrix; Cut: in Rep := Zero) is
      use Ada.Text_IO, Txt_Int_IO;
   begin
      for I in A'Range(1) loop
         for J in A'Range(2) loop
            if abs(A(I,J))>Cut then
               Put("A(");
               Put(I,2);
               Put(",");
               Put(J,2);
               Put(") = ");
               Txt_Put(Current_Output,A(I,J));
               New_Line;
            end if;
         end loop;
      end loop;
      New_Line;
   end Show;
end Lin.IO;
