
package body Lin is

   pragma Suppress(Storage_Check);


   procedure SetZero(B: out Vector) is
   begin
      for I in B'Range loop
         B(I) :=Comp_Zero;
      end loop;
   end SetZero;


   procedure SetZero(A: out Matrix) is
      pragma Suppress(Storage_Check);
   begin
      for I in A'Range(1) loop
         for J in A'Range(2) loop
            A(I,J) := Comp_Zero;
         end loop;
      end loop;
   end SetZero;


   procedure RealPart(A: in Matrix; B: out RealMatrix) is
   begin
      for I in A'Range(1) loop
         for J in A'Range(2) loop
            B(I,J) := RealPart(A(I,J));
         end loop;
      end loop;
   end RealPart;


   procedure ImPart(A: in Matrix; B: out RealMatrix) is
   begin
      for I in A'Range(1) loop
         for J in A'Range(2) loop
            B(I,J) := ImPart(A(I,J));
         end loop;
      end loop;
   end ImPart;


   function RealPart(A: in Matrix) return RealMatrix is
      B: RealMatrix(A'First(1)..A'Last(1),A'First(2)..A'Last(2));
   begin
      RealPart(A,B);
      return B;
   end RealPart;


   function ImPart(A: in Matrix) return RealMatrix is
      B: RealMatrix(A'First(1)..A'Last(1),A'First(2)..A'Last(2));
   begin
      ImPart(A,B);
      return B;
   end ImPart;


   procedure SetZero(B: out RealVector) is
   begin
      for I in B'Range loop
         B(I) :=Zero;
      end loop;
   end SetZero;


   procedure SetZero(A: out RealMatrix) is
   begin
      for I in A'Range(1) loop
         for J in A'Range(2) loop
            A(I,J) := Zero;
         end loop;
      end loop;
   end SetZero;


   procedure Transpose(A: in out Matrix) is
      AA: Matrix(A'Range(1),A'Range(2));
   begin
      for I in A'Range(1) loop
         for J in A'Range(2) loop
            AA(I,J) := A(J,I);
         end loop;
      end loop;
      A:=AA;
   end Transpose;


   procedure Transpose(A: in out RealMatrix) is
      AA: RealMatrix(A'Range(1),A'Range(2));
   begin
      for I in A'Range(1) loop
         for J in A'Range(2) loop
            AA(I,J) := A(J,I);
         end loop;
      end loop;
      A:=AA;
   end Transpose;


   procedure SetColumn(J: in Integer; V: in Vector; A: in out Matrix) is
   begin
      for I in A'Range(1) loop
         A(I,J) := V(I);
      end loop;
   end SetColumn;


   procedure SetColumn(J: in Integer; V: in RealVector; A: in out RealMatrix) is
   begin
      for I in A'Range(1) loop
         A(I,J) := V(I);
      end loop;
   end SetColumn;


   procedure SetZero(W: out Sparse) is
   begin
      W(0) := (0,0,Comp_Zero);
   end SetZero;


   function InRange(I,J: Integer; A: Matrix) return Boolean is
   begin
      if I>=A'First(1) and  I<=A'Last(1) and J>=A'First(2) and  J<=A'Last(2) then
         return True;
      else
         return False;
      end if;
   end InRange;
end Lin;
