with Reps,Comps;
use Reps,Comps;

generic
package Lin is

   pragma Pure;
   type Trip is
      record
         I: Integer;
         J: Integer;
         R: Comp;
      end record;

   Getting_Tired: exception;
   Matrix_Full: exception;

   type Vector is array (Integer range <>) of Comp;
   type Pivot is array(Integer range <>) of Integer;
   type Matrix is array (Integer range <>, Integer range <>) of Comp;
   type Sparse is array(Integer range <>) of Trip;
   type RealVector is array (Positive range <>) of Rep;
   type RepArray is array (Integer range <>) of Rep;
   type RealMatrix is array (Integer range <>, Integer range <>) of Rep;


   procedure SetZero(B: out Vector);                                           -- B := 0
   procedure SetZero(A: out Matrix);                                           -- A := 0
   procedure RealPart(A: in Matrix; B: out RealMatrix);                        -- RealPart(A)
   procedure ImPart(A: in Matrix; B: out RealMatrix);                          -- ImPart(A)
   function RealPart(A: in Matrix) return RealMatrix;                          -- RealPart(A)
   function ImPart(A: in Matrix) return RealMatrix;                            -- ImPart(A)
   procedure SetZero(B: out RealVector);                                       -- B := 0
   procedure SetZero(A: out RealMatrix);                                       -- A := 0
   procedure SetZero(W: out Sparse);                                           -- W := 0
   procedure Transpose(A: in out Matrix);                                      -- W := 0
   procedure Transpose(A: in out RealMatrix);                                  -- W := 0
   procedure SetColumn(J: in Integer; V: in Vector; A: in out Matrix);         -- A(.,J) := V
   procedure SetColumn(J: in Integer; V: in RealVector; A: in out RealMatrix); -- A(.,J) := V
   function InRange(I,J: Integer; A: Matrix) return Boolean;
end Lin;
